/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
import com.jcraft.jsch.*;
import java.io.*;
import java.io.File;


/**
 *
 * @author marcelo
 */
public class SCPFileSender {

    private static String serverName = "aragorn.elo.utfsm.cl";
    private static String userName = "Ingrese usuario";
    private static String password = "Ingrese pass";

    private Session session;
    private Channel channel;
    private ChannelSftp c;
    private ChannelExec channelssh;

    class Update extends Thread{

        private String fileDir;
        private String remoteDir;
        private String fileName;

        public Update(String fileDir, String fileName, String remoteDir){
            this.fileDir = fileDir;
            this.remoteDir = remoteDir;
            this.fileName = fileName;
        }

        private void sendRecursive(String sourcePath, String destinationPath) throws SftpException{
            String current = null;
            try{
                current = c.pwd();
                File sourceFile = new File(sourcePath);
                if (sourceFile.isFile()) {

                    c.cd(destinationPath);

                    System.out.println("Uploading file " + sourceFile.getName()
                        + " to " + destinationPath);
                    c.put(new FileInputStream(sourceFile), sourceFile.getName(),
                            ChannelSftp.OVERWRITE);
                    System.out.println("Upload succesful!");
                }
                else {
                    File[] files = sourceFile.listFiles();

                    if (files != null){


                        c.cd(destinationPath);
                        System.out.println("Directorio actual = " + c.pwd());
                        SftpATTRS attrs = null;
                        // check if the directory is already existing
                        try {
                            attrs = c.stat(destinationPath + "/" + sourceFile.getName());
                        } catch (Exception e) {
                            System.out.println(destinationPath + "/" + sourceFile.getName() + " not found");
                        }

                        // else create a directory
                        if (attrs != null) {
                            System.out.println("Directory exists IsDir=" + attrs.isDir());
                        } else {
                            System.out.println("Creating dir " + sourceFile.getName());
                            c.mkdir(sourceFile.getName());

                        }

                        for (File f: files) {
                            sendRecursive(f.getAbsolutePath(), destinationPath + "/" + sourceFile.getName());
                        }

                    }
                }
            }
            catch(Exception e){
                System.out.println(e);
                System.exit(-1);
            }
            c.cd(current);
        }
        public void run(){
            try{
                System.out.println("GOLHASLCKKANDVKNADV");
                sendRecursive(fileDir+fileName, remoteDir);
            }
            catch(Exception c){
                System.out.println(c);
            }
        }
    }

    class Delete extends Thread{

        private String fileDir;
        private String remoteDir;

        public Delete(String fileDir, String remoteDir){
            this.fileDir = fileDir;
            this.remoteDir = remoteDir;
        }

        public void run(){
            try{
                c.rm(remoteDir+"/"+fileDir);
                System.out.println("Removing file");

            }
            catch(Exception e){

                try{
                    channelssh.setCommand("rm -rf "+remoteDir+ "/" +fileDir);
                    channelssh.connect();
                    channelssh.disconnect();
                    System.out.println("rm -rf " + remoteDir + "/" + fileDir);
                }
                catch(Exception f){}
            }
            System.out.println("Done deleting");

        }
    }

    public SCPFileSender(){

    }

    public void createSession(){
        JSch jsch = new JSch();

        try{
            session = jsch.getSession(userName, serverName, 22);
            session.setPassword(password);
            jsch.setKnownHosts("/home/marcelo/.ssh/known_hosts");
            jsch.addIdentity("/home/marcelo/.ssh/id_rsa");
            System.out.println("Connectando a servidor");
            session.connect();
            System.out.println("Conexión exitosa!\nAbriendo canal SFTP");

            channel = session.openChannel("sftp");
            channel.connect();
            System.out.println("Canal SFTP abierto.\nAbriendo canal SSH");
            c = (ChannelSftp) channel;
            channelssh = (ChannelExec) session.openChannel("exec");
            System.out.println("Canal SSH abierto. Directorio actual en servidor: " + c.pwd());



        }
        catch(Exception e){
            System.out.println(e);
            System.exit(-1);
        }
    }

}
